#!/bin/sh
#
#./studna-red.py -r gene_ref_file -i gene_inf_file -c chrom_names_file -t taxon_id -s output_database -d description
#
# 'gene_ref_file' .. file with gene data, e.g. from gene2refseq.gz
# 'gene_inf_file' .. file with gene names, e.g. from gene_info.gz
#
# the files can be downloaded by ftp from NCBI site:
#  ftp://ftp.ncbi.nih.gov/gene/DATA/
#
# 'chrom_names_file' contains information about used chromosomes,
# it should be prepared, 'chr_NC_gi' can be used as precursors.
# see the provided example for human chromosomes.
#

./studna-red.py -r grefs9606.txt -i ginfo9606.txt -c chromosomes9606.txt -t 9606 -s studna.sqlite -d "H.s.s."
./studna-red.py -r grefs9598.txt -i ginfo9598.txt -c chromosomes9598.txt -t 9598 -s studna.sqlite -d "P.tr."

