/*
 * Counting library for the StuDNA upstream sites.
 * (C) Martin Saturka http://www.bioplexity.org/
 * Opensource, available under the MIT/X license.
 */

void tuplecounts(int *tuplen, int *tupcounts, int *veclen, int *vec,
  int *seplen, int *seps, int *tupaux, int *retval)
{
  int ituplen = *tuplen;
  int iveclen = *veclen;
  int iseplen = *seplen;

  unsigned int curval;
  int ilimit;
  int touse;

  int *pcounts;
  int gap, off, val1, val2;
  int ind, pos, sepind;
  unsigned int  value;

  int ialt1, ialt2, ind1m, ind2m;
  unsigned int xcase1, xcase2;

  const int offstep = 1 << (4 * ituplen);

  ilimit = iveclen - (ituplen - 1);
  for (ind = 0; ind < ilimit; ind++) {
    curval = 0;
    touse = 1;
    for (pos = 0; pos < ituplen; pos++) {
      if (-1 == vec[ind + pos]) {
        tupaux[ind] = -1;
        touse = 0;
        break;
      }
      else {
        curval <<= 2;
        curval += (unsigned) vec[ind + pos];
      }
    }
    if (touse) {
      tupaux[ind] = curval;
    }
  }

  pcounts = tupcounts;
  for (sepind = 0; sepind < iseplen; sepind++) {
    gap = seps[sepind];
    off = ituplen + gap;

    ilimit = iveclen - (gap + (2 * ituplen) - 1);
    for (ind = 0; ind < ilimit; ind++) {
      val1 = tupaux[ind];
      val2 = tupaux[ind + off];
      if ((-1 < val1) || (-1 < val2)) {
        value = (unsigned) val1;
        value = (value << (2 * ituplen)) + val2;
        pcounts[value] = 1;
      }

    }

    pcounts = pcounts + (3 * offstep);
  }

  pcounts = tupcounts;
  for (sepind = 0; sepind < iseplen; sepind++) {

   for (ind = 0; ind < offstep; ind++) {
    if (pcounts[ind]) {
      pcounts[ind + offstep] = 1;
      pcounts[ind + (2 * offstep)] = 1;

      for (ialt1 = 0; ialt1 < (2 * ituplen); ialt1++) {
        for (xcase1 = 1; xcase1 < 4; xcase1++) {
          ind1m = ind ^ (xcase1 << (2 * ialt1));
          pcounts[ind1m + offstep] = 1;
          pcounts[ind1m + (2 * offstep)] = 1;

          if (ialt1 >= ituplen) {
            continue;
          }

          for (ialt2 = ituplen; ialt2 < (2 * ituplen); ialt2++) {
            for (xcase2 = 1; xcase2 < 4; xcase2++) {
              ind2m = ind1m ^ (xcase2 << (2 * ialt2));
              pcounts[ind2m + (2 * offstep)] = 1;
            }
          }

        }
      }

    }
   }
   pcounts = pcounts + (3 * offstep);
  }

  return;
}


